//---------------------------------------------------------------------------
//Program Filtr
//Slou k filtraci vkov sloky
//napsal Jan Havrlnat jako soust diplomov prce
//--Automatizovan tvorba prostorovch model map--
//v roce 2002
//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ExtDlgs.hpp>
#include <ComCtrls.hpp>
class HLSColor;
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
  __published:    // IDE-managed Components
  TImage *Image1;
  TButton *Button1;
  TButton *Button3;
  TScrollBar *ScrollBar1;
  TScrollBar *ScrollBar2;
  TLabel *Label1;
  TLabel *Label2;
  TLabel *Label3;
  TLabel *Label4;
  TScrollBar *ScrollBar3;
  TLabel *Label5;
  TScrollBar *ScrollBar4;
  TLabel *Label6;
  TLabel *Label7;
  TLabel *Label8;
  TLabel *Label9;
  TLabel *Label10;
  TLabel *Label11;
  TLabel *Label12;
  TScrollBar *ScrollBar5;
  TScrollBar *ScrollBar6;
  TLabel *Label13;
  TLabel *Label14;
  TLabel *Label15;
  TButton *Button7;
  TProgressBar *ProgressBar1;
  TOpenDialog *OpenDialog1;
  TSaveDialog *SaveDialog1;
  TScrollBar *ScrollBar7;
  TScrollBar *ScrollBar8;
  TImage *Image2;
  TCheckBox *CheckBox1;
  TCheckBox *CheckBox2;
  void __fastcall Button1Click(TObject *Sender);
  void __fastcall Button3Click(TObject *Sender);
  void __fastcall ScrollBar2Change(TObject *Sender);
  void __fastcall ScrollBar3Change(TObject *Sender);
  void __fastcall ScrollBar4Change(TObject *Sender);
  void __fastcall ScrollBar5Change(TObject *Sender);
  void __fastcall ScrollBar6Change(TObject *Sender);
  void __fastcall Image2MouseUp(TObject *Sender, TMouseButton Button,
                                TShiftState Shift, int X, int Y);
  void __fastcall Button7Click(TObject *Sender);
  void __fastcall Image2MouseDown(TObject *Sender,
                                  TMouseButton Button, TShiftState Shift, int X, int Y);
  void __fastcall ScrollBar7Change(TObject *Sender);
  void __fastcall ScrollBar8Change(TObject *Sender);
  void __fastcall ScrollBar7Scroll(TObject *Sender,
                                   TScrollCode ScrollCode, int &ScrollPos);
  void __fastcall ScrollBar8Scroll(TObject *Sender,
                                   TScrollCode ScrollCode, int &ScrollPos);
  void __fastcall CheckBox1Click(TObject *Sender);
  void __fastcall CheckBox2Click(TObject *Sender);
  void __fastcall ScrollBar1Change(TObject *Sender);
  void __fastcall FormActivate(TObject *Sender);
  private:    // User declarations
  public:     // User declarations
  __fastcall TForm1(TComponent* Owner);
  __fastcall ~TForm1();
  void Test(TImage* Image);
  bool  Hranice (HLSColor*,int ,int ,int,int ,int ,int );
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------

char *a;  //ukazatel na pole s obrzkem pro uloen
double MAX(double r,double g, double b)
{
  return max(max(r, g),b);
}
double MIN(double r,double g, double b)
{
  return min(min(r, g),b);
}
//---------------------------------------------------------------------------
class HLSColor
{
  public :
  double h, s, b;
};
//---------------------------------------------------------------------------
class RGBColor
{
  public :
  double r, g, b;
  RGBColor(){}
  RGBColor(double ra,double ga,double ba){r=ra;g=ga;b=ba;}
  void barva(int ba){ b =((16711680&ba)>>16);g=(65280&ba)>>8; r=255&ba;}
  int rgb(){return ((int)r) +((int)g<<8)+((int)b<<16);}
};
//---------------------------------------------------------------------------
int RGB_TO_HLS (RGBColor rgb, HLSColor& hls )
{  //convert(r, g, b), each in [0, 1], to h, l, s
  // HLSColor hls;
  double mx, mn;
  RGBColor tmp;
  rgb.r=rgb.r/255.0;
  rgb.g=rgb.g/255.0;
  rgb.b=rgb.b/255.0;
  mx = MAX(rgb.r, rgb.g, rgb.b);
  mn = MIN(rgb.r, rgb.g, rgb.b);
  hls.b=mx*100.0;
  if (mx == mn)
  {          // compute saturation
    hls.s = 0.0;
    hls.h = 0.0;

  }   // color is gray
  else
  {                  // color is chromatic
    hls.s = 100-(mn/mx*100);
    tmp.r = (mx - rgb.r)/(mx - mn);
    tmp.g = (mx - rgb.g)/(mx - mn);
    tmp.b = (mx - rgb.b)/(mx - mn);
    if (rgb.r == mx)      hls.h = tmp.b - tmp.g;
    else if (rgb.g == mx) hls.h = 2.0 + tmp.r - tmp.b;
    else if (rgb.b == mx) hls.h = 4.0 + tmp.g - tmp.r; hls.h *= 60.0;
    if (hls.h < 0.0)
      hls.h += 360.0;
  }
  return hls.h;
}

#endif